#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file PlayScreen.py
 @brief PlayScreen
 @date $Date$


"""
import sys
import time
sys.path.append(".")

from threading import Lock
lock = Lock()

# Import RTM module
import RTC
import OpenRTM_aist

import Img

# capture
import numpy as np
from numpy import array
import cv2

cameraImageQueue = []
# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
playscreen_spec = ["implementation_id", "PlayScreen", 
		 "type_name",         "PlayScreen", 
		 "description",       "PlayScreen", 
		 "version",           "1.0.0", 
		 "vendor",            "kanamura", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class PlayScreen
# @brief PlayScreen
# 
# 
class PlayScreen(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_cameraImage = OpenRTM_aist.instantiateDataType(Img.TimedCameraImage)
		"""
		"""
		self._cameraImageIn = OpenRTM_aist.InPort("cameraImage", self._d_cameraImage)
		self._d_status = OpenRTM_aist.instantiateDataType(RTC.TimedLong)
		"""
		"""
		self._statusIn = OpenRTM_aist.InPort("status", self._d_status)


		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		# Bind variables and configuration variable
		
		# Set InPort buffers
		self.addInPort("cameraImage",self._cameraImageIn)
		self.addInPort("status",self._statusIn)
		
		# Set OutPort buffers
		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		
		return RTC.RTC_OK
	
	###
	## 
	## The finalize action (on ALIVE->END transition)
	## formaer rtc_exiting_entry()
	## 
	## @return RTC::ReturnCode_t
	#
	## 
	#def onFinalize(self):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The startup action when ExecutionContext startup
	## former rtc_starting_entry()
	## 
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The shutdown action when ExecutionContext stop
	## former rtc_stopping_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	##
	#
	# The activated action (Active state entry action)
	# former rtc_active_entry()
	#
	# @param ec_id target ExecutionContext Id
	# 
	# @return RTC::ReturnCode_t
	#
	#
	def onActivated(self, ec_id):
		print('Start image view')

                #cv2.namedWindow("img", cv2.WINDOW_AUTOSIZE)

                self._img = np.zeros((480, 640, 3), np.uint8)
                self._storedPoint = None
                #self._storeFinalText = None
                #self._storedTime = None

		return RTC.RTC_OK
	
	##
	#
	# The deactivated action (Active state exit action)
	# former rtc_active_exit()
	#
	# @param ec_id target ExecutionContext Id
	#
	# @return RTC::ReturnCode_t
	#
	#
	def onDeactivated(self, ec_id):
	        cv2.destroyAllWindows()
                print("Stop image view.")

		return RTC.RTC_OK
	
	##
	#
	# The execution action that is invoked periodically
	# former rtc_active_do()
	#
	# @param ec_id target ExecutionContext Id
	#
	# @return RTC::ReturnCode_t
	#
	#
	def onExecute(self, ec_id):
		if self._statusIn.isNew():
                        m_status = self._statusIn.read()
                        self._storedPoint = m_status.data
                        global pointCountA
                        global textColorA

                        pointCountA = 'Rea team'
                        textColorA = 255, 0, 0

                        if self._storedPoint == 0:
                                pointCountA = 'Red team lose...'
                                textColorA = 255, 0, 0  
                                

                #cameraImage
                
                if self._cameraImageIn.isNew():
                        img = self._cameraImageIn.read()
                        global cameraImageQueue
                        lock.acquire()
                        # cameraImage = np.zeros((480, 640, 3), np.uint8)
			#image.data.image.raw_data
                        cameraImage = np.fromstring(img.data.image.raw_data, dtype = np.uint8).reshape(img.data.image.height, img.data.image.width, -1)

                        
                        resizedCameraImage = cv2.resize(cameraImage, (img.data.image.width*2, img.data.image.height*2))



                        if not self._storedPoint == None:
                                                                
                                cv2.putText(resizedCameraImage,
                                            #'%d' % (self._storedPoint),
                                            '%s' % (pointCountA),
                                            (50,100),
                                            cv2.FONT_HERSHEY_COMPLEX, 3, (textColorA), 3, cv2.LINE_AA)
                        cameraImageQueue.append(resizedCameraImage)

                        lock.release()
	
		return RTC.RTC_OK
	
	###
	##
	## The aborting action when main logic error occurred.
	## former rtc_aborting_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The error action in ERROR state
	## former rtc_error_do()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The reset action that is invoked resetting
	## This is same but different the former rtc_init_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The state update action that is invoked after onExecute() action
	## no corresponding operation exists in OpenRTm-aist-0.2.0
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##

	##
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The action that is invoked when execution context's rate is changed
	## no corresponding operation exists in OpenRTm-aist-0.2.0
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	



def PlayScreenInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=playscreen_spec)
    manager.registerFactory(profile,
                            PlayScreen,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    PlayScreenInit(manager)

    # Create a component
    comp = manager.createComponent("PlayScreen")

def showImage():
        key = ''
        lock.acquire()
        #print 'show'
        if len(cameraImageQueue) > 0:
                #print 'Image'
                cameraImage = cameraImageQueue.pop()
                cv2.imshow('image', cv2.cvtColor(cameraImage, cv2.COLOR_BGR2RGB))
                key = cv2.waitKey(1)
                
        lock.release()

        if key == 'q':
                return True
        return False

def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager(True) 

	while True:
        	time.sleep(0.1)
                if showImage() == True:
                        return



if __name__ == "__main__":
	main()

